const PZOption = (props) => {

  const pzDisplayStyle = { 1: 'square', 2: 'circle', 3: 'radio', 4: 'checkbox', 5: 'select', 6: 'input' };
  const promizeOptions = props.pzOptions;
  const options = Array.from(Object.keys(props.pzOptions), k => props.pzOptions[k]);
  let pzOptions = options.length > 0 ? options.sort(function (a, b) {
    if (a.promize_attribute_value) {
      return a.promize_attribute_value.sort_id - b.promize_attribute_value.sort_id;
    }
  }) : []
  const pzTabData = props.pzSubTab ? props.pzSubTab : props.pzTab
  const pzTabStyle = (pzTabData.tab_style) ? JSON.parse(pzTabData.tab_style) : '';
  const displayType = (pzDisplayStyle[pzTabStyle.display]) ? pzDisplayStyle[pzTabStyle.display] : 'square';

  if (displayType === "select") {
    return <div class="pz-design-dropdown">
      {pzTabStyle.enableAttrName && <p className="pz-design-item-title">{props.pzAttribute.promize_attribute.attribute_name}</p>}

      <div class="pz-custom-dp">
        <button class="pz-custom-dp-button" onClick={e => props.pzSelectHandler(e, 'selectOption')}><span>{props.pzActiveOptions[pzTabData.promize_tab_id] ? promizeOptions[props.pzActiveOptions[pzTabData.promize_tab_id][1]].promize_attribute_value.option_name : "Select option"}</span><i class="fa fa-caret-down"></i></button>
        <ul class={props.pzActiveDropdown === 'selectOption' ? "pz-custom-dp-list option active" : "pz-custom-dp-list"}>
          {
            pzOptions.length > 0 && pzOptions.map((tabOption, option_index) => {
              const pzTabOption = tabOption;
              const pzOptionValue = pzTabOption.promize_attribute_value;
              if (props.pzHideAttributeValues.includes(pzTabOption.promize_tab_attribute_values_id) || (props.pzBaseType && pzOptionValue.option_code && !pzOptionValue.option_code.includes(props.pzBaseType))) {
                return ''
              }
              let activeClass = (props.pzActiveOptions[pzTabData.promize_tab_id] && props.pzActiveOptions[pzTabData.promize_tab_id][1] == pzTabOption.promize_tab_attribute_values_id) ? true : false
              return <li className={(activeClass) ? 'option active' : 'option'} onClick={() => { props.clickHandler(pzTabOption) }}>
                {/* <div class="pz-custom-dp-img">
                      <img src="" />
                    </div> */}
                <span className={(activeClass) ? 'option active' : 'option'}>{pzOptionValue.option_name}</span>
              </li>
            })
          }
        </ul>
      </div>
    </div>
  } else if (displayType === "input") {
    return <div class="pz-design-input">
      {/* <input type="text"></input> */}
    </div>
  } else if (displayType === "radio") {
    return <div class="pz-design-radios">
      {pzTabStyle.enableAttrName && <p className="pz-design-item-title">{props.pzAttribute.promize_attribute.attribute_name}</p>}
      {
        pzOptions.length > 0 && pzOptions.map((tabOption, option_index) => {
          const pzTabOption = tabOption;
          const pzOptionValue = pzTabOption.promize_attribute_value;
          if (props.pzHideAttributeValues.includes(pzTabOption.promize_tab_attribute_values_id) || (props.pzBaseType && pzOptionValue.option_code && !pzOptionValue.option_code.includes(props.pzBaseType))) {
            return ''
          }
          let activeClass = (props.pzActiveOptions[pzTabData.promize_tab_id] && props.pzActiveOptions[pzTabData.promize_tab_id][1] == pzTabOption.promize_tab_attribute_values_id) ? true : false
          return <label for={pzOptionValue.option_name} class="pz-cust-rdio">{pzOptionValue.option_name}
            <input type="radio" name="radio" id={pzOptionValue.option_name} value="" checked={(activeClass) ? 'checked' : ''} onChange={() => { props.clickHandler(pzTabOption) }} />
            <span class="checkmark"></span>
          </label>

        })
      }
    </div>
  } else if (displayType == "checkbox") {
    return <div class="pz-design-checkbox">
      {pzTabStyle.enableAttrName && <p className="pz-design-item-title">{props.pzAttribute.promize_attribute.attribute_name}</p>}
      {
        pzOptions.length > 0 && pzOptions.map((tabOption, option_index) => {
          const pzTabOption = tabOption;
          const pzOptionValue = pzTabOption.promize_attribute_value;
          if (props.pzHideAttributeValues.includes(pzTabOption.promize_tab_attribute_values_id) || (props.pzBaseType && pzOptionValue.option_code && !pzOptionValue.option_code.includes(props.pzBaseType))) {
            return ''
          }
          let activeClass = (props.pzActiveOptions[pzTabData.promize_tab_id] && props.pzActiveOptions[pzTabData.promize_tab_id][1] == pzTabOption.promize_tab_attribute_values_id) ? true : false
          return <label for={pzOptionValue.option_name} class="pz-cust-checkbox">{pzOptionValue.option_name}
            <input type="checkbox" name={pzOptionValue.option_name} id={pzOptionValue.option_name} value="" checked={(activeClass) ? 'checked' : ''} onChange={(e) => { props.clickHandler(undefined, undefined, e, pzTabOption) }} />
            <span class="checkmark"></span>
          </label>

        })
      }
    </div>
  } else if (displayType == "circle" || displayType == "square") {
    return <div className={'pz-design-item-wrapper'}>
      {pzTabStyle.enableAttrName && <p className="pz-design-item-title">{props.pzAttribute.promize_attribute.attribute_name}</p>}
      <ul className={"pz-design-item-list"}>
        {pzOptions.length > 0 && pzOptions.map((tabOption, option_index) => {
          const pzTabOption = tabOption;
          const pzOptionValue = pzTabOption.promize_attribute_value;
          if (props.pzHideAttributeValues.includes(pzTabOption.promize_tab_attribute_values_id) || (props.pzBaseType && pzOptionValue.option_code && !pzOptionValue.option_code.includes(props.pzBaseType))) {
            return ''
          }
          if (pzTabOption && Object.keys(pzTabOption).length > 0) {
            const pzOptionColorCode = (pzOptionValue.option_value && pzOptionValue.option_value.charAt(0) == '#' && pzCheckValidColorCode(pzOptionValue.option_value)) ? pzOptionValue.option_value : (pzCheckValidColorCode('#' + pzOptionValue.option_value)) ? '#' + pzOptionValue.option_value : '';
            let activeClass = (props.pzActiveOptions[pzTabData.promize_tab_id] && props.pzActiveOptions[pzTabData.promize_tab_id][1] == pzTabOption.promize_tab_attribute_values_id) ? true : false
            let pzOptionThumbImg = '';
            if (pzOptionValue.promize_images && (Object.keys(pzOptionValue.promize_images).length > 0)) {
              pzOptionThumbImg = pzOptionValue.promize_images.find((val) => {
                return val.image_type == "option_thubnail_image"
              })
            }
            pzOptionThumbImg = pzOptionThumbImg ? props.pzImgUrl.concat(pzOptionThumbImg.image_url.replace(props.pzReplaceImg, '')) : '';
            let style = {
              background: `${pzOptionColorCode} url(${pzOptionThumbImg})`,
              width: (pzTabStyle && pzTabStyle.width > 0) ? pzTabStyle.width : '40',
              height: (pzTabStyle && pzTabStyle.height > 0) ? pzTabStyle.height : '40',
              borderRadius: (pzDisplayStyle[pzTabStyle.display] == 'circle') ? '50%' : '',
            };
            return (
              <li key={pzOptionValue.option_id} className={`pz-design-item ${(activeClass) ? 'active' : ''}`} onClick={() => { props.clickHandler(pzTabOption) }}>
                <div className="pz-design-item-content" title={pzOptionValue.option_name}>
                  {(pzOptionColorCode || pzOptionThumbImg) && <div className="pz-design-item-img" style={style}></div>}
                  <div className="pz-design-item-name">{pzOptionValue.option_name}</div>
                  {(pzOptionValue.option_price) &&
                    <div className="pz-design-item-price">
                      <span>${pzOptionValue.option_price.toFixed(2)}</span>
                    </div>
                  }
                </div>
              </li>
            );
          }
        })
        }
      </ul>
    </div>
  }
}